'use strict';
'use warning';
/**
 * DKA JS FRAMEWORK
 * @author Yovangga Anandhika
 * @email dhikaprivate@gmail.com
 * @version 1.0
 * @description
 * All Right Reserved.
 * */

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Api", {
  enumerable: true,
  get: function get() {
    return _Api["default"];
  }
});
Object.defineProperty(exports, "Database", {
  enumerable: true,
  get: function get() {
    return _Database["default"];
  }
});
Object.defineProperty(exports, "Functions", {
  enumerable: true,
  get: function get() {
    return _Functions["default"];
  }
});
Object.defineProperty(exports, "Hardware", {
  enumerable: true,
  get: function get() {
    return _Hardware["default"];
  }
});
Object.defineProperty(exports, "Helper", {
  enumerable: true,
  get: function get() {
    return _Helper["default"];
  }
});
Object.defineProperty(exports, "Options", {
  enumerable: true,
  get: function get() {
    return _Options["default"];
  }
});
Object.defineProperty(exports, "Security", {
  enumerable: true,
  get: function get() {
    return _Security["default"];
  }
});
Object.defineProperty(exports, "Server", {
  enumerable: true,
  get: function get() {
    return _Server["default"];
  }
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _Functions = _interopRequireDefault(require("./Functions"));

var _Helper = _interopRequireDefault(require("./Helper"));

var _Server = _interopRequireDefault(require("./Server"));

var _Security = _interopRequireDefault(require("./Security"));

var _Config = _interopRequireDefault(require("./Config"));

var _Database = _interopRequireDefault(require("./Database"));

var _Options = _interopRequireDefault(require("./Options"));

var _Hardware = _interopRequireDefault(require("./Hardware"));

var _Api = _interopRequireDefault(require("./Api"));

/**
 *
 * @typedef {Object} DKA
 * @property {Functions} DKA.Functions
 */
var DKA = {
  Functions: _Functions["default"],
  Helper: _Helper["default"],
  Security: _Security["default"],
  Database: _Database["default"],
  Server: _Server["default"],
  Options: _Options["default"],
  Hardware: _Hardware["default"],
  Api: _Api["default"],

  get config() {
    return _Config["default"];
  },

  set config(config) {
    _Config["default"] = (_lodash["default"].extend(_Config["default"], config), function () {
      throw new Error('"' + "Config" + '" is read-only.');
    }());
  }

};
global.DKA = DKA;
global.Server = _Server["default"];
global.DKAnum = 0;
global.DKAServerConfig = [];
var _default = DKA;
exports["default"] = _default;
//# sourceMappingURL=index.module.d.js.map